#! /usr/bin/perl
#* ============================================================
# * File  : pserver_init.pl
# * Author: Eric Giesselbach <ericgies@kabelfoon.nl>
# * Date  : 2007-09-30
# * Description : MythStream Player Service parser example
# *               Starts stream with pserv_example player service
# * ============================================================ */
# *
# * This parser sets the stream item pserv field to pserver
# * MythStream calls that parser when the stream item reaches state "playing"
# * Parser pserver takes control of MythStream textarea and image fields
# *
# * See pserver.pl for more info
# *

use English;
use Digest::MD5;
require "./lastfm/lastfm_helper.pl";

#ws.audioscrobbler.com/radio/handshake.php
#version=1.0&platform=linux&username=usernamehere&password=md5
sub lastFM_handshake
{
   local $url = shift;

      # unix timestamp
   my $timestamp = unixtime();

   # lastfm auth
   $md5->new();
   $md5->add($config{'password'});
   my $auth = $md5->hexdigest();

   http_lastFM_request($url,
   ( 
    'version'    => '1.0',
    'platform' => 'linux',
    'username' => 'username here',
    'passwordmd5' => $auth,
   )
   );

   if ($handshake{'RESULT'} eq "OK" && ! ($handshake{'session'} eq "FAILED") )
   {
      $handshake{'RESULT'} = "OK";
      $config{'session'} = $handshake{'session'};
      $config{'base_url'} = $handshake{'base_url'};
      $config{'base_path'} = $handshake{'base_path'};
      &write_config();
   }
      else
   {
      print "ERROR: handshake failed: " . $handshake{'msg'} . "\n";
   }
}


#------------------------------------------------------------------------------
# Init
#------------------------------------------------------------------------------

  $md5 = new Digest::MD5;

  &read_config();
  &read_parse();    # get commandline parameters into @in
  
  $urlPrefix = "http://fake";
  $source    = $in[0]; # source filename from command line
  $itemurl   = $in[1];
  $itemname  = $in[2]; # Stream item name
    
  # remove quotes if any
  $itemurl =~ s/^\"?(.*?)\"?$/$1/;
  $itemname =~ s/^\"?(.*?)\"?$/$1/;

  ($uName, $uValue) = decodeFakeURL($itemurl); # get uName, uValue

  if ($uName eq "username" || $uName eq "password" )
  {
     $config{$uName} = $uValue;
     &write_config();
  }


#------------------------------------------------------------------------------
# Init and Run
#------------------------------------------------------------------------------

# no authentication info available
if (! $config{'username'} || ! $config{'password'})
{
   # store stream item to start after authentication
   if ($uName ne "username" && $uName ne "password" )
   {
      $config{'pendingName'} = $itemname;
      $config{'pendingUrl'} = $itemurl;
      &write_config();
   }

   setError("LastFM authentication information not available",
            "Please set username and password");

   if ($config{'username'}) { $mod = "Change";} else {$mod = "Enter"; }
   addItem("$mod LastFM username",
         "http://fake#username#<:Give LastFM username::" . $config{'username'} . ":>",
         "*lastfm/handshake",
         "");

   if ($config{'password'}) { $mod = "Change";} else {$mod = "Enter"; }

   addItem("$mod LastFM password",
         "http://fake#password#<:Give LastFM password::" . $config{'password'} . ":>",
         "*lastfm/handshake",
         "");
}
  else
{

   # username and password just set
   if ($uName eq "username" || $uName eq "password" )
   {
      # pass to handshake (uName = request)
      addItem($config{'pendingName'}, $config{'pendingUrl'}, "*lastfm/handshake", "");
   }
   
   if ($uName eq "request")
   {
      $myurl = "http://ws.audioscrobbler.com/radio/handshake.php";
      
      lastFM_handshake($myurl);

      if ( $handshake{'RESULT'} eq "OK")
      {
      if ( $uValue eq "")
      {

         addItem("LastFM Stream", $handshake{'stream_url'}, "", "lastfm/nowplaying");
      }
         else
      {

            # switch station
            $url = "http://" . $config{'base_url'} . $config{'base_path'} . "/adjust.php";
            http_lastFM_request($url, ('url' => $uValue) );
            if ( $handshake{'RESULT'} eq "OK" && $handshake{'response'} eq "OK")
            {
              addItem("LastFM Stream", $handshake{'stream_url'}, "", "lastfm/nowplaying");
            }
      }
         
      }

   }

}

sendItems();


