#! /usr/bin/perl
#* ============================================================
# * File        : omroep/metaplayer.pl
# * Version     : 0.1
# * Author      : Eric
# * Date        : 2008-07-12
# * Description: constructs metaplayer url with two md5 vars
# *
# * Requires:
# * - mythstream v0.17_2
# * - perl stuff
# *
# *  
# * ============================================================ */


use English;
use XML::DOM;
use HTML::Entities;
use LWP::UserAgent;

#------------------------------------------------------------------------------
# Init
#------------------------------------------------------------------------------

&read_parse();    # get commandline parameters into @in
$source = $in[0]; # source filename from command line
$cururl = $in[1]; # current url
$stname = $in[2]; # stream name

# remove quotes from url
  $cururl =~ s/^\"?(.*?)\"?$/$1/;
# remove quotes from name
  $stname =~ s/^\"?(.*?)\"?$/$1/;

my $doc = XML::DOM::Document->new;
my $head = $doc->createXMLDecl ('1.0');
my $root = $doc->createElement('items');

sub newNode
{
  local $name  = shift;
  local $value = shift;
  local $node = $doc->createElement($name);
  local $text = $doc->createTextNode($value);
  $node->appendChild($text);
  
  return $node;
}

#------------------------------------------------------------------------------
# read file into $data
#------------------------------------------------------------------------------

$datafile = $source;
open( INFO, "<$datafile" );      # Open file for reading
undef $/;
$data = <INFO>;                 # Read all
close(INFO);

#------------------------------------------------------------------------------
# Parse playlist
#------------------------------------------------------------------------------

              
## var securityCode = 'dae3fccb3d6d6de113b535e505fd6417';

# current url: http://player.omroep.nl/?aflID=6578044&amp;md5=19b5d7130681ebd04e98d3ecfb450a4e

# sept 2008: they moved the security code to javascript. Just get it then (zucht - maar al moet ik een browser in een VM runnen...)

sub dump_lines
{
    # <script type="text/javascript" src="js/initialization.js.php?aflID=7901362"></script>

    my $jsdata = "";
    my $code = "";
    my $handler = "";

    if (@matches = ( $data =~ m/(js\/initialization[^"]+)"/ ) )
    {
      $jsurl = "http://player.omroep.nl/" . @matches[0];
    }
  
    if (@matches = ( $data =~ m/securityCode\s*=\s*'([^']+)'/ ) )
    {
      $code = @matches[0];
    }
    
    if ($code ne "")
    {
    	$cururl = $stname; # play url in name, see below
	    # insert path xml/metaplayer.xml.php into cururl
	    $cururl =~ s/\?/xml\/metaplayer.xml.php?/;

	    # append second md5=$code
	    $cururl .= "&md5=$code";

	    $handler = "omroep/meta2url";
    }
	else
    {
	$stname = $cururl; # play url in name
	$cururl = $jsurl;
	$handler = "omroep/metaplayer";
    }

    $item = $doc->createElement('item');
    $root->appendChild($item);

    $name = decode_entities($name);
     
    $item->appendChild( newNode('name', $stname ) );
    $item->appendChild( newNode('url', $cururl) );
    $item->appendChild( newNode('descr', "Uitzending gemist: $jsurl: $jsdata") );
    $item->appendChild( newNode('handler', $handler) );
   
   # bug: werkt niet bij doorskippen met 1 item 
   if ($handler eq "omroep/metaplayer")
   {
    $item = $doc->createElement('item');
    $root->appendChild($item);

    $item->appendChild( newNode('name', "Klik op item hierboven (bug workaround)" ) );
    $item->appendChild( newNode('url', $cururl) );
    $item->appendChild( newNode('descr', "Uitzending gemist: $jsurl: $jsdata") );
    $item->appendChild( newNode('handler', $handler) );
   }  
}

#------------------------------------------------------------------------------
# search url's in $data and place them in special format
#------------------------------------------------------------------------------

&dump_lines();

print $head->toString;
print $root->toString;
print "\n";

#--------------------------------------------------------------------------------
# get command line parameters
#--------------------------------------------------------------------------------

sub read_parse 
{
  local (*in) = @_ if @_;
  local ($i);
  push(@in, @ARGV);
  foreach $i (0 .. $#in) { $in[$i] =~ s/\+/ /g;}
  return scalar(@in);
}



