#! /usr/bin/perl
#* ============================================================
# * File        : retrovision/catlist.pl
# * Author      : Eric
# * Date        : 2007-12-07
# * Description : parses mainpage categories
# * ============================================================ */

use English;
use XML::DOM;
use HTML::Entities;

#------------------------------------------------------------------------------
# Init
#------------------------------------------------------------------------------

&read_parse();    # get commandline parameters into @in
$source = $in[0]; # source filename from command line

my $doc = XML::DOM::Document->new;
my $head = $doc->createXMLDecl ('1.0');
my $root = $doc->createElement('items');

sub newNode
{
  local $name  = shift;
  local $value = shift;
  local $node = $doc->createElement($name);
  local $text = $doc->createTextNode($value);
  $node->appendChild($text);
  
  return $node;
}

#------------------------------------------------------------------------------
# read file into $data
#------------------------------------------------------------------------------

$datafile = $source;
open( INFO, "<$datafile" );      # Open file for reading
undef $/;
$data = <INFO>;                 # Read all
close(INFO);

#------------------------------------------------------------------------------
# Parse playlist
#------------------------------------------------------------------------------

              
## .... cat-item-153"><a href="http://retrovision.tv/?cat=104" title="View all posts filed under Adventure">Adventure</a>
# was later changed to:
## ....<a href='http://retrovision.tv/?tag=adventure' class='tag-link-104' title='3 topics' style='font-size: 8.56pt;'>Adventure</a>

sub dump_lines
{
  # get rid of newlines
  $data =~ s/\n/ /g;
  # multiple spaces
  $data =~ s/\s\s+/ /g;
  # format station links
  $data = decode_entities($data);

  while ($data =~ m/<a[^>]+href='(http:\/\/retrovision.tv\/\?tag=[^']+)'[^>]+>([^<]+)<\/a>/gi)
  {
     $item = $doc->createElement('item');
     $root->appendChild($item);
     
 
     $name = $2;
     $name =~ s/\%([A-Fa-f0-9]{2})/pack('C', hex($1))/seg;

     $item->appendChild( newNode('name', "$2") );
     $item->appendChild( newNode('url', $1) );
     $item->appendChild( newNode('descr', "select category: $2") );
     $item->appendChild( newNode('handler', "retrovision/vidlist") );
  }
  
}

#------------------------------------------------------------------------------
# search url's in $data and place them in special format
#------------------------------------------------------------------------------

&dump_lines();

binmode STDOUT, ":utf8";

print $head->toString;
print $root->toString;
print "\n";

#--------------------------------------------------------------------------------
# get command line parameters
#--------------------------------------------------------------------------------

sub read_parse 
{
  local (*in) = @_ if @_;
  local ($i);
  push(@in, @ARGV);
  foreach $i (0 .. $#in) { $in[$i] =~ s/\+/ /g;}
  return scalar(@in);
}



