#! /usr/bin/perl
#* ============================================================
# * File        : retrovision/videoplay.pl
# * Author      : Eric
# * Date        : 2007-12-07
# * Description : returns single video url (handler for vidlist)
# * ============================================================ */


use English;
use XML::DOM;
use HTML::Entities;

#------------------------------------------------------------------------------
# Init
#------------------------------------------------------------------------------

&read_parse();    # get commandline parameters into @in
$source = $in[0]; # source filename from command line

my $doc = XML::DOM::Document->new;
my $head = $doc->createXMLDecl ('1.0');
my $root = $doc->createElement('items');

sub newNode
{
  local $name  = shift;
  local $value = shift;
  local $node = $doc->createElement($name);
  local $text = $doc->createTextNode($value);
  $node->appendChild($text);
  
  return $node;
}

#------------------------------------------------------------------------------
# read file into $data
#------------------------------------------------------------------------------

$datafile = $source;
open( INFO, "<$datafile" );      # Open file for reading
undef $/;
$data = <INFO>;                 # Read all
close(INFO);

#------------------------------------------------------------------------------
# Parse playlist
#------------------------------------------------------------------------------

              
##   <param name="src" value="http://retrovision.tv:8008/Ernest_Bliss.avi"
## OR
##   addVariable("file", "http://retrovision.tv:8008/His_Girl_Friday.flv"); 

sub dump_lines
{
  # get rid of newlines
  $data =~ s/\n/ /g;
  # multiple spaces
  $data =~ s/\s\s+/ /g;
  # format station links

  while ($data =~ m/<param\sname="src"\svalue="([^"]+)"/gi)
  {
     # single non-flash video
     $item = $doc->createElement('item');
     $root->appendChild($item);
        
     $item->appendChild( newNode('name', "$1") );
     $item->appendChild( newNode('url', $1) );
     $item->appendChild( newNode('descr', "$1") );
     # $item->appendChild( newNode('handler', "retrovision/vidlist") );   
  }
  
  while ($data =~ m/addVariable\("file",\s"([^"]+)"/gi)
  {
     # url is a single flash video?
     $item = $doc->createElement('item');
     $root->appendChild($item);
        
     $item->appendChild( newNode('name', "$1") );
     $item->appendChild( newNode('url', $1) );
     $item->appendChild( newNode('descr', "$1") );

     if ($1 =~ m/XML/)
     {
       # url is a flashplayer XML playlist
       $item->appendChild( newNode('handler', "retrovision/xmllist") );
     }
  }
  
}

#------------------------------------------------------------------------------
# search url's in $data and place them in special format
#------------------------------------------------------------------------------

&dump_lines();

print $head->toString;
print $root->toString;
print "\n";

#--------------------------------------------------------------------------------
# get command line parameters
#--------------------------------------------------------------------------------

sub read_parse 
{
  local (*in) = @_ if @_;
  local ($i);
  push(@in, @ARGV);
  foreach $i (0 .. $#in) { $in[$i] =~ s/\+/ /g;}
  return scalar(@in);
}



