#! /usr/bin/perl
#* ============================================================
# * File        : youtube/vid.pl
# * Release     : 5
# * Author      : Eric
# * Date        : 2009-08-30
# * Description : parser for youtube feed
# * ============================================================ */

use English;
use XML::DOM;
use HTML::Entities;

#------------------------------------------------------------------------------
# Init
#------------------------------------------------------------------------------

&read_parse();    # get commandline parameters into @in
$source = $in[0]; # source filename from command line
$sname = $in[2];

# remove quotes from sname
$sname =~ s/^\"?(.*?)\"?$/$1/;

my $doc = XML::DOM::Document->new;
my $head = $doc->createXMLDecl ('1.0');
my $root = $doc->createElement('items');

sub newNode
{
  local $name  = shift;
  local $value = shift;
  local $node = $doc->createElement($name);
  local $text = $doc->createTextNode($value);
  $node->appendChild($text);
  
  return $node;
}

#------------------------------------------------------------------------------
# read file into $data
#------------------------------------------------------------------------------

$datafile = $source;
open( INFO, "<$datafile" );      # Open file for reading
undef $/;
$data = <INFO>;                 # Read all
close(INFO);

#------------------------------------------------------------------------------
# Parse playlist
#------------------------------------------------------------------------------




# &dump_lines();

# OLD: BASE_YT_URL:'http://youtube.com/',video_id:'iYWrMWH6rGA',l:'83',t:'OEgsToPDskL33Dsy3NGyvOx2YJG_MEtK',sk:
# NEW: swfArgs = { ..., "t": "zzzzzzzzz", "fexp": "903705%2C904000%2C905400", ... , "video_id": "xxxxxxxxx", .... }

my $a, $b;

if ( ($a, $b) = $data =~ /swfArgs\s\=\s\{.*?"t":\s*"([^"]+)".+?"video_id":\s*"([^"]+)"/ )
{
      $url = "http://www.youtube.com/get_video?video_id=$b&t=$a";

      $item = $doc->createElement('item');
      $root->appendChild($item);
      
      $item->appendChild( newNode('name', "play: $sname") );
      $item->appendChild( newNode('url',  $url) );
      $item->appendChild( newNode('descr', "") );
      $item->appendChild( newNode('handler', "") );

      if (! ($playlist_enable == 1) )
      {
         $item = $doc->createElement('item');
         $root->appendChild($item);
         
         $item->appendChild( newNode('name', "download: $sname") );
         $item->appendChild( newNode('url',  $url) );
         $item->appendChild( newNode('descr', "") );
         $item->appendChild( newNode('handler', "STREAM_DL") );
      }
}

print $head->toString;
print $root->toString;
print "\n";

#--------------------------------------------------------------------------------
# get command line parameters
#--------------------------------------------------------------------------------

sub read_parse 
{
  local (*in) = @_ if @_;
  local ($i);
  push(@in, @ARGV);
  foreach $i (0 .. $#in) { $in[$i] =~ s/\+/ /g;}
  return scalar(@in);
}



