#!/bin/bash
#* ============================================================
# * File        : zoomin/asx2url.pl
# * Release     : 1
# * Author      : Wauter <wowtorx@gmail.com>
# * Date        : 2008-01-05
# * Description : parses ASX
# *
# * Requires:
# * - mythstream v0.18.1
# * - unix tools: bash, sed
# *
# * Required by:
# * - zoomin/index.pl
# * ============================================================ */

sourcefile="$1"
sourceurl="$2"
sourcename="$3"

# (myth)stream(tuned) expects the following xml output (descr, handler, meta nodes are optional)
# 
# <items>
#   <item>
#      <name>stream name</name>
#      <url>stream url</url>
#      <descr>stream description</descr>                      
#      <handler>handling hint* or parser script name</handler>   
#      <meta>                                                      
#         <name>meta data name</name>
#         <content>the meta data</content>
#         <viewer>viewer*</viewer>
#      </meta>
#      <meta>                                                
#         <name>meta data name</name>
#         <content></content>
#         <viewer></viewer>
#      </meta>
#      ...
#   </item>
#   <item>
#      <name>stream name</name>
#      <url>stream url</url>
#      <descr>stream description</descr>                    
#      <handler></handler>   
#   </item>
#   ...
# </items>  

# *handling hint: STREAM_* (e.g. STREAM_DL starts file download)
# *viewer: text, html, inline

item_ptn='.*"\(mms://[^"]*\)".*'

echo '<items>'
<$sourcefile sed '
	\_'"$item_ptn"'_ !d

	i\ <item>
	s@'"$item_ptn"'@  <name>'"$sourcename"'</name>\n  <url>\1</url>@
	a\ </item>
'
echo '</items>'
