#!/bin/bash
#* ============================================================
# * File        : zoomin/index.pl
# * Release     : 1
# * Author      : Wauter <wowtorx@gmail.com>
# * Date        : 2008-01-05
# * Description : parses http://www.zoomin.tv/site/index.cfm?cid=X
# *
# * Requires:
# * - mythstream v0.18.1
# * - zoomin/asx2url.pl
# * - unix tools: bash, sed
# *
# * To use this parser
# *  add this stream item in MythStream:
# *      Stream Name   : Zoomin.TV
# *      Stream URL    : http://www.zoomin.tv/site/index.cfm?cid=<language>
# *      Stream URL    : http://www.zoomin.tv/site/index.cfm?cat=<category>&cid=<language>
# *      Stream Handler: zoomin/index
# *
# * Where <language> is one of:
# *   0. Netherlands (Dutch)
# *   1. Belgium (Dutch)
# *   2. Belgium (French)
# *   3. France (French)
# *   4. Germany (German)
# *   5. Spain (Spanish)
# *   6. Italy (Italian)
# *   7. World (English)
# * 
# * Valid <category> values are language specific (see http://www.zoomin.tv/).
# * ============================================================ */

sourcefile="$1"
sourceurl="$2"
sourcename="$3"

# (myth)stream(tuned) expects the following xml output (descr, handler, meta nodes are optional)
# 
# <items>
#   <item>
#      <name>stream name</name>
#      <url>stream url</url>
#      <descr>stream description</descr>                      
#      <handler>handling hint* or parser script name</handler>   
#      <meta>                                                      
#         <name>meta data name</name>
#         <content>the meta data</content>
#         <viewer>viewer*</viewer>
#      </meta>
#      <meta>                                                
#         <name>meta data name</name>
#         <content></content>
#         <viewer></viewer>
#      </meta>
#      ...
#   </item>
#   <item>
#      <name>stream name</name>
#      <url>stream url</url>
#      <descr>stream description</descr>                    
#      <handler></handler>   
#   </item>
#   ...
# </items>  

# *handling hint: STREAM_* (e.g. STREAM_DL starts file download)
# *viewer: text, html, inline

item_ptn=".*ftvlaunch(\([[:digit:]]*\),3,'\([[:alpha:]]*\)')[^>]*>\([^<]*\)</a></b><br>[[:space:]]*\([^<]*\)</td>.*"

echo '<items>'
<$sourcefile sed '
	\_'"$item_ptn"'_ !d

	i\ <item>
	s@'"$item_ptn"'@  <name>\3</name>\n  <url>http://www.zoomin.tv/asx/dsp_asxplaylist.cfm?id=\1\&amp;pid=\2\&amp;quality=3\&amp;WMCache=0\&amp;iebr=0</url>\n  <descr>\3</descr>@
	a\  <handler>zoomin/asx2url</handler>
	a\ </item>
'
echo '</items>'
